package io.reisub.dreambot.cagility;

import org.dreambot.api.methods.interactive.GameObjects;
import org.dreambot.api.methods.interactive.Players;
import org.dreambot.api.methods.map.Area;
import org.dreambot.api.wrappers.interactive.GameObject;

public class Obstacle {
    private final int id;
    private final Area[] areas;
    private Obstacle next;

    public Obstacle(int id, Area... areas) {
        this.id = id;
        this.areas = areas;
    }

    public int getID() {
        return this.id;
    }

    public GameObject getGameObject() {
        return GameObjects.closest(getID());
    }

    public Obstacle getNext() {
        return this.next;
    }

    public void setNext(Obstacle next) {
        this.next = next;
    }

    public boolean isPlayerInArea() {
        for (Area area : areas) {
            if (area.contains(Players.localPlayer())) {
                return true;
            }
        }

        return false;
    }
}
