package io.reisub.dreambot.cfisher.tasks;

import io.reisub.dreambot.util.CInventory;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodContext;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.script.TaskNode;

public class Drop extends TaskNode {
    private final String[] fishNames;

    public Drop(String[] fishNames) {
        this.fishNames = fishNames;
    }

    @Override
    public boolean accept() {
        int r  = Calculations.random(100);

        if (r < 6) {
            return Inventory.fullSlotCount() >= 27;
        } else if (r < 9) {
            return Inventory.fullSlotCount() >= 26;
        } else if (r < 10) {
            return Inventory.fullSlotCount() >= 25;
        }

        return Inventory.isFull();
    }

    @Override
    public int execute() {
        if (Inventory.isFull()) {
            MethodContext.sleep(0, 1200);
        }

        Inventory.setDropPattern(CInventory.verticalSnakeDropPattern);

        Inventory.dropAll(fishNames);

        MethodContext.sleepUntil(() -> !Inventory.contains(fishNames), 1300);

        return Calculations.random(250, 400);
    }
}
