package io.reisub.dreambot.cfisher.tasks;

import io.reisub.dreambot.util.Constants;
import io.reisub.dreambot.util.Util;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodContext;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.interactive.NPCs;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.interactive.NPC;

public class Fish extends TaskNode {
    private final String[] fishNames;

    public Fish(String[] fishNames) {
        this.fishNames = fishNames;
    }

    @Override
    public boolean accept() {
        return Util.playerIsIdle() && !Inventory.isFull();
    }

    @Override
    public int execute() {
        if (Inventory.contains(fishNames)) {
            MethodContext.sleep(0, 2400);
        }

        NPC npc = NPCs.closest(Constants.FISHING_SPOT);

        if (npc == null) return 0;

        npc.interactForceLeft(Constants.USE_ROD);

        Util.sleepUntilMovingAndAnimating();

        return Calculations.random(80, 200);
    }
}
