package io.reisub.dreambot.cwintertodt.tasks;

import io.reisub.dreambot.util.Constants;
import io.reisub.dreambot.util.Util;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.interactive.GameObjects;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.interactive.GameObject;

public class Chop extends TaskNode {

    private final WintertodtTask parent;

    public Chop(WintertodtTask parent) {
        this.parent = parent;
    }

    @Override
    public boolean accept() {
        return !Inventory.isFull() && parent.getKindlingCount() == 0 && !parent.shouldBurnBeforeRunningOutOfTime() && !parent.isBurning() && parent.getEnergy() >= 5;
    }

    @Override
    public int execute() {
        if (parent.isInterrupted()) {
            parent.setInterrupted(false);
            return 0;
        }

        GameObject roots = GameObjects.closest(Constants.BRUMA_ROOTS);

        if (roots == null) return 0;

        roots.interactForceLeft(Constants.CHOP);

        Util.sleepUntilMovingAndAnimating();

        return Calculations.random(200, 300);
    }
}
