package io.reisub.dreambot.util;

import io.reisub.dreambot.util.ui.UI;
import org.dreambot.api.script.AbstractScript;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

public abstract class CAbstractScript extends AbstractScript implements MouseListener {
    private final UI ui;

    public CAbstractScript() {
        ui = UI.getInstance(getSDNName());
    }

    public UI getUI() {
        return ui;
    }

    @Override
    public void onPaint(Graphics g){
        ui.draw(g);
    }

    @Override
    public void onPause() {
        ui.pause();
    }

    @Override
    public void onResume() {
        ui.resume();
    }

    @Override
    public void mouseClicked(MouseEvent mouseEvent) {
        ui.mouseClicked(mouseEvent);
    }

    @Override
    public void mousePressed(MouseEvent mouseEvent) {
        ui.mousePressed(mouseEvent);
    }

    @Override
    public void mouseReleased(MouseEvent mouseEvent) {
        ui.mouseReleased(mouseEvent);
    }

    @Override
    public void mouseEntered(MouseEvent mouseEvent) {
        ui.mouseEntered(mouseEvent);
    }

    @Override
    public void mouseExited(MouseEvent mouseEvent) {
        ui.mouseExited(mouseEvent);
    }
}
