package io.reisub.dreambot.util.event.health;

import io.reisub.dreambot.util.event.AbstractEvent;
import org.dreambot.api.Client;
import org.dreambot.api.methods.skills.Skill;
import org.dreambot.api.methods.skills.Skills;

import java.util.EventListener;

public class HealthEvent extends AbstractEvent {
    private int lastHealth = -1;

    @Override
    public void run() {
        while (run && Client.getInstance().getScriptManager().isRunning()) {
            try {
                Thread.sleep(600);
            } catch (InterruptedException ignored) {}

            if (Client.getInstance().getScriptManager().isPaused()) {
                continue;
            }

            if (lastHealth == -1) {
                lastHealth = Skills.getBoostedLevels(Skill.HITPOINTS);
                continue;
            }

            int currentHealth = Skills.getBoostedLevels(Skill.HITPOINTS);

            if (currentHealth > lastHealth) {
                for (EventListener l : listeners) {
                    ((HealthListener) l).onHealthIncreased(lastHealth, currentHealth);
                    ((HealthListener) l).onHealthChanged(lastHealth, currentHealth);
                }
            } else if (currentHealth < lastHealth) {
                for (EventListener l : listeners) {
                    ((HealthListener) l).onHealthDecreased(lastHealth, currentHealth);
                    ((HealthListener) l).onHealthChanged(lastHealth, currentHealth);
                }
            }
        }
    }
}
