package io.reisub.dreambot.util.tasks.kitten;

import io.reisub.dreambot.util.CNPC;
import io.reisub.dreambot.util.Constants;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodContext;
import org.dreambot.api.methods.dialogues.Dialogues;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.interactive.NPC;

public class InteractKitten extends TaskNode {
    private final KittenTask parent;

    public InteractKitten(KittenTask parent) {
        this.parent = parent;
    }

    @Override
    public boolean accept() {
        NPC kitten = CNPC.getNPCInteractingWithPlayer(Constants.KITTEN);

        return parent.wantsAttention() &&
                kitten != null &&
                kitten.canReach();
    }

    @Override
    public int execute() {
        NPC kitten = CNPC.getNPCInteractingWithPlayer(Constants.KITTEN);

        if (kitten == null) return 0;

        stroke(kitten);
        stroke(kitten);

        return Calculations.random(250, 400);
    }

    public void stroke(NPC kitten) {
        if (!kitten.interact(Constants.INTERACT)) {
            return;
        }

        MethodContext.sleepUntil(Dialogues::areOptionsAvailable, Calculations.random(3000, 3500));

        Dialogues.chooseFirstOptionContaining(Constants.STROKE);

        MethodContext.sleep(1500, 2000);
        MethodContext.sleepUntil(Dialogues::inDialogue, Calculations.random(4000, 4500));
    }
}
